/*
NOTE: NOT all these programs are simultaneously useful.
Some of them have more or less the same function.
They are here for test purpose
*/

// ----------------------------------------------------------------------------- ADMISSIBLE_COLOR
struct particle admissible_color(struct particle part,struct matrix M,int option,int cmax)
{
/*
For Coloring/Frequency assignment problem, try to adapt the position so that all constraints are respected, 
eventually by increasing the number of colors used

Note: edge list representation of the graph is a global variable (dplus)

*/

/*
For each  node successively (option=0)
or for each carefully chosen node (option >0)
	modify its color a few as possible so that all its constraints are satisfied
*/
/*
option2 =  0: assign to i the consistent color with the most occurences		
	
option2 =  2: assign the smallest possible color
*/
int					attempt;
int					best_color;
int					best_node;

struct particle		best_part;
struct vector_int	candidate1,candidate2;
int					c0,c;
int					c1,c2;
int					coeff_m;
struct color 		color;

int					color_min;
//struct color		colored_nodes;
int					confinement;

int					count;
float				d;
int					dmax;
struct color_list	hood_color;
int					inode;
int					i,j,j1,k,l,m;
int					largest,largest2;
int					loop;

int					max_attempt;
int					n_c,n_c1;
struct vector_int	n_color,not_color;

int					OK;
int					option2;
struct particle 	partt;
struct particle		partt2;
struct vector_int	used_times[2]; // [color] [number of times it is used] 


max_attempt=dplus.dmax;

//max_attempt=1;


color_min=diff_color(part.pos);

attempt=0;

begin:

count=0; // Just for test


option2=2;

if (option<3)
	confinement=option;
else
{
	confinement=1;
	loop=0;
}
//____________________________

try:

// Initialize the numbers of non modified neighbours

not_color.size=M.size;
for (inode=0;inode<M.size;inode++)
{
	not_color.val[inode]=dplus.dplus[inode].size;// Number of non modified neighbours
}


// Set color to NA (arbitrary value for "not modified")
color.size=M.size;
for (i=0;i<color.size;i++) 
	color.val[i]=NA;
	
partt=part;

used_times[0].size=0;

if (confinement==2)
{
	
	// Compute the two criteria for the first time
	largest=0;
	hood_color.size=0;
	for (inode=0;inode<M.size;inode++) // For each possible node i ...
	{	
		// Count how many _different_ (modified) colors in the neighbourhood
		n_color.val[inode]=0;

	}
}


//printf("\n inode loop. confinement %i\n",confinement);
for (inode=0;inode<M.size;inode++) // Choose the node to modify
{
	switch (confinement)
	{
		case 0:
		best_node=inode;
		break;

		//__________________
		case 1:
		//Select a non modified node i with the maximum of non modified neighbours

		dmax=-1;
		for (i=0;i<color.size;i++) // For each node ...
		{
			if (color.val[i]<=NA) // ... if not modified ...
			{
				if (not_color.val[i]>dmax) // ... check if it has the max of non modified neighbours
				{
					dmax=not_color.val[i];
					best_node=i;
				}
			}
		}


		// Decrease the number of non modified neighbours for each neighbour
		// (Note: works only for symmetric matrix)

		//printf("node %i dplus.dplus[node];size %i",node,dplus.dplus[node].size);
		for (i=0;i<dplus.dplus[best_node].size;i++)
		{
			not_color.val[dplus.dplus[best_node].val[i]]=not_color.val[dplus.dplus[best_node].val[i]]-1;
		}
		break;

		//___________________
		case 2:
		/*
		select the non modified node i which has the largest number of modified neighbours with different colors
			in case of a tie, select the one with the largest number of unmodified neighbours
				in case of a tie, select at random
		*/

		candidate1.size=0;
		largest2=0;
//printf("\n case 2");
		for (i=0;i<M.size;i++) // First criterion
		{
			if (color.val[i]>NA) continue; // Already modified
			if (n_color.val[i]<largest) continue; // Not enough modified neighbours
				candidate1.val[candidate1.size]=i;
				candidate1.size=candidate1.size+1;
				if (not_color.val[i]>largest2) largest2=not_color.val[i];
		}

		if (candidate1.size==1)
		{
			best_node=candidate1.val[0];
			break;
		}

		candidate2.size=0;

		for (i=0;i<candidate1.size;i++)
		{
			j=candidate1.val[i];

//printf("\n j, not_color.val[j] %i %i", j,not_color.val[j]);
			if (not_color.val[j]<largest2) continue;

				candidate2.val[candidate2.size]=j;
				candidate2.size=candidate2.size+1;
		}
//printf("\n candidate2.size %i",candidate2.size);

		if (candidate2.size==0)
		{
			printf("\n candidate1.size %i",candidate1.size);

			printf("\n largest2 %i",largest2);

			printf("\n ERROR admissible_color. candidate2.size=0");
			//best_node=candidate1.val[alea(0,candidate1.size-1)];

			infinite2:; goto infinite2;
			break;	
		}

		i=alea(0,candidate2.size-1);
		best_node=candidate2.val[i];
		
		//best_node=candidate2.val[0];
		break;
		
		//___________________
		default:
		best_node=inode;
		break;
	}

//printf(" %i",best_node);
	// Now, try to modify the color, "as few as possible"
	c0= (int)partt.pos.x[best_node];
	c=c0;

//printf("\n c %i",c);
	for (k=0;k<dplus.dplus[best_node].size;k++) // ... check the modified neighbours
	{
		j=dplus.dplus[best_node].val[k];
		if (color.val[j]<=NA) continue; // Not modified
		d=(float) fabs(c0-partt.pos.x[j])-M.val[best_node][j];
		if (d>=0) continue; // ... consistent
		
		// best_node has at least one unsatisfied constraint
		m=0;
		coeff_m=1;
		
		next_c:
		//coeff_m=-coeff_m;
		m=m+1;
		//for (m=1;m<M.size;m++) // Try another color
		{
			c=c0+coeff_m*m;
			OK=0;
//printf("\n c %i",c);
			//if (c>xmax)  goto minus_m;
			
			for (l=0;l<dplus.dplus[best_node].size;l++) // ... check the modified neighbours
			{
				j1=dplus.dplus[best_node].val[l];
				if (color.val[j1]<=NA) continue;

				d=(float) fabs(c-partt.pos.x[j1])-M.val[best_node][j1];
				if (d>=0) continue; // color c is ok for neighbour k
					 goto minus_m; // color c is not ok for neighbour k => try another color
//goto next_c;
			}
			// Color c is OK for all neighbours
//printf("\n node %i, color %.0f => %i", j,partt.pos.x[j],c);

//goto put_color;
			c1=c; 
			OK=1;
			
			minus_m:
			c=c0-coeff_m*m;
			//if (c<xmin) goto next_c;
			
			for (l=0;l<dplus.dplus[best_node].size;l++) // ... check the neighbours
			{
				j1=dplus.dplus[best_node].val[l];
				if (color.val[j1]<=NA) continue;

				d=(float) fabs(c-partt.pos.x[j1])-M.val[best_node][j1];
				if (d>=0) continue; // color c is ok for neighbour k
					 goto next_c; // color c is not ok for neighbour k => try another color
			}
			// Color c is OK for all neighbours
			if (OK==0) goto put_color;
	
			
			// Both c1 and c are possible. Find the most already used
			
			if (option2==0)
			{
				n_c=0;
				n_c1=0;
				for (l=0;l<used_times[0].size;l++)
				{
					c2=used_times[0].val[l];
					if (c2==c1) n_c1=used_times[1].val[l];
					if (c2==c) n_c=used_times[1].val[l];
				}
			
				if (n_c1>n_c) c=c1;
				if (n_c1==n_c)
				{		
					if (fabs(c1)<fabs(c)) c=c1;
					//c=MIN(c,c1);
					//if (alea_float(0,1)<0.5) c=c1;
				}
			}
			if (option2==2) if (fabs(c1)<fabs(c)) {c=c1;goto put_color;}
				
			
		//next_c:;
		}//m. Next color
		
	}//k.  Next neighbour

	put_color:

	partt.pos.x[best_node]= (float)c;
	best_color=c;

//printf(" %i/%i",best_node,best_color);	
//	
	color.val[best_node]=best_color;
	
	if (confinement==2) //  Modify the number of different colors in the neighbourhoods
	{
		// Modify the criteria (remember the matrix is symmetric)

		for (i=0;i<dplus.dplus[best_node].size;i++) // For each best_node's neighbour ...
		{
			j=dplus.dplus[best_node].val[i]; // (neighbour)
			if (color.val[j]>NA) continue; //  already modified

			not_color.val[j]=not_color.val[j]-1; // decrease the number of non modified j's neighbours
			if (not_color.val[j]<0)
			{
				printf("\n ERROR. admissible_color. , not_color.val[j] %i %i. Max : %i",j, not_color.val[j], dplus.dplus[j].size);
				infinite:; goto infinite;
			}
			// Number of different colors used in the (modified) hood
			for (k=0;k<dplus.dplus[j].size;k++) 
			{
				l=dplus.dplus[j].val[k];
				if (color.val[l]<=NA) continue;
				if (color.val[l]==best_color && l!=best_node) goto next_i3;// 
				 // Color best_color already used in the neighbour 
			}

			// best_color not already used in the neighbourhood of j

			n_color.val[j]=n_color.val[j]+1;
		next_i3:;
		}
		
		largest=0; // Largest number of different colors in the hood for unmodified nodes

		for (i=0;i<M.size;i++)
		{
			if (color.val[i]>NA) continue;
			if (n_color.val[i]>largest)
			{
				largest=n_color.val[i];
			}
		}	
	}
	
	// Update how many times each color is used
		
		for (i=0;i<used_times[0].size;i++)
		{
			c=used_times[0].val[i];
			if (c==best_color)
			{
				used_times[1].val[i]=used_times[1].val[i]+1;
				goto end_used_times;
			}
		}
		// New color
			used_times[0].val[used_times[0].size]=best_color;
			used_times[1].val[used_times[0].size]=1;
			used_times[0].size=used_times[0].size+1;
		
		end_used_times:;

}// inode. Next node

if (option>2)
{
	if (loop==0)
	{
		partt2=partt;
		confinement=2;
		loop=loop+1;
		goto try;
	}
	else // Keep the best
	{
		c1=diff_color(partt.pos);
		c2=diff_color(partt2.pos);
		if (c2<c1) partt=partt2;
	}
}

/*
// Better to verify ...

color=convert_position_to_color(partt.pos);
i=check_color(color,M,dplus);
printf("\n Number of unsatisfied constraints: %i",i);

printf("\n Number of colors used: %i",i);
*/


//printf("\n admissible_color end");

best_part=partt;
attempt=attempt+1;

if (attempt<max_attempt)
{ 
	i=diff_color(best_part.pos);

	if (i<=cmax) return best_part;
	if (i<color_min)
	{
		color_min=i;	
	}

//printf("\n cmax %i",cmax);

	goto begin;
}


//printf("\n best_part.pos %f",best_part.pos.x[0]);
return best_part;
}


// ----------------------------------------------------------------------------- CHECK_COLOR
int	check_color(struct color color,struct matrix M, struct dplus dplus)
{ 
// Number of unsatisfied constraints
int i,j,k;
int uncons;

uncons=0;
for (i=0;i<M.size;i++)
{
	for (j=0;j<dplus.dplus[i].size;j++)
		{
		k=dplus.dplus[i].val[j];
		if (fabs(color.val[i]-color.val[k])<M.val[i][k]) uncons=uncons+1;
		}
}
return uncons;
}


// ----------------------------------------------------------------------------- COEFF_TIMES_VEL_COLOR
struct velocity coeff_times_vel_color(float coeff,struct velocity vel,struct matrix M)
{
/*
Option 0:  classical weighting

Option 1:
The graph has N nodes.
- choose a node at random
- from this node, build a connexe graph (as dense as possible) with coeff*N nodes (coeff<=1)
- keep just the velocity components corresponding to the nodes of this graph


*/
float coefft;
struct vector	g;
int				i,j;
int				n;
int				n1,n2;
int				option;
struct vector	used={0};
struct velocity velt; //{int size;float v[Max_vel];float ek;float v2[Max_vel];int combin;}

//printf("\n coeff_times_vel_color. coeff=%f, vel.size %i, vel.combin %i",coeff);
//display_velocity(vel);

option=0;

if (coeff==1)
{
	return vel;
}


velt.size=M.size;
velt.combin=0;


if (option==0)
{
	for (i=0;i<velt.size;i++)
	{
		velt.v[i]=coeff*vel.v[i];
	}
	return velt;
}

for (i=0;i<velt.size;i++) velt.v[i]=0;

if (coeff>1) coefft=(float) coeff-(float)floor(coeff); else coefft=coeff; // Just in case coeff>1

n=(int) coefft*M.size;
//printf("\n coefft, M.size,n: %f %i %i",coefft,M.size,n);
if (n==0) return velt;

i=alea(0,velt.size-1); // Choose the first node
g.x[0]=(float)i;
g.size=1;
used.x[i]=1;
//printf("\n first node %i",i);

if (n>1)
{
	for (j=0;j<g.size;j++) // For each node already used
	{
		n1=(int) g.x[j]; // n1 = node already used
		for (n2=0;n2<M.size;n2++) // Look for neighbours
		{
//printf("\n n1,n2 %i,%i",n1,n2);
		if (n1==n2) continue;
		if (used.x[n2]==1) continue; // Already used
		if (M.val[n1][n2]<=0) continue;  // No edge
//printf(": add %i",n2);
			g.x[g.size]=(float)n2;
			g.size=g.size+1;  // Note the trick: the upper bound of the loop is modified inside the loop
			if (g.size>=n) goto end;
				used.x[n2]=1;
		}
	
	}
}

end:

for (i=0;i<g.size;i++) 
{
	j=(int) g.x[i];
	velt.v[j]=vel.v[j];
}

//display_velocity(velt);
return velt;
}

// ----------------------------------------------------------------------------- COLOR_0
struct position		color_0(struct matrix M,struct dplus dplus,struct position color,struct param param)
{
// Backtrack

int					c;
int					c_diff;

int					cmax;

int					c_min,c_max;
struct position 	colort;
int					first;
int					i;
int					j;
int					k;
struct vector_int	old_c;

//printf("\n Color_0. ");
cmax=(int) param.max_fr;


colort=color;

for (i=0;i<M.size;i++)

{
	c_min=(int) param.H.min[i];

	old_c.val[i]=c_min;

}
	
// First non assigned node


//printf("\n color_0 ici1");
for (i=0;i<M.size;i++)
{
	if (color.x[i]>NA) continue;
			first=i;
			goto coloring;	
}

 // All nodes are already colored!!
c_diff=diff_color(color);
if (c_diff<=cmax) colort.adm=1; else colort.adm=0;
return colort;


coloring:

//printf("\n color_0 ici2, first %i",first);


i=0;

try_i:
//printf("\n i %i/ ",i);
if (color.x[i]>NA) // Already colored in initial coloring
{
	i=i+1;
	if (i>=M.size) goto success;
		goto try_i;
} 

c_max=(int) param.H.max[i];
for (c=old_c.val[i];c<=c_max;c++)
{
	colort.x[i]=(float)c;
	// Test is consistent
//printf("\n   c %i",c);
//printf(" %i",c);
		for (j=0;j<dplus.dplus[i].size;j++)
		{
			k=dplus.dplus[i].val[j]; // Neighbour
//printf("\n     k %i",k);
			if (k>=i) continue; // Not already colored
//printf("\n      i/c, k/colort.x[k], M: %i/%i <-> %i/%i   %i",i,c,k,colort.x[k], M.val[i][k]);		
			if (fabs(c-colort.x[k])<M.val[i][k]) // if color c is not admissible
			{
//printf(" => not OK");				
				goto next_c; // Not OK
			}	
		}
		
		// Test is not too many colors
		c_diff=diff_color(colort);
//printf("\n               c_diff %i",c_diff);
		if (c_diff<=cmax) goto OK;
//printf("   => not OK");
			

next_c:;	
}

goto previous_i;

	OK:	


	i=i+1;
	if (i==M.size) goto success;
		old_c.val[i-1]=c;
		goto try_i;


previous_i:

colort.x[i]=(float)NA;

c_min=(int) param.H.min[i];
old_c.val[i]=c_min;

minus_i:
i=i-1;

if (i<first) goto impossible;

if (color.x[i]>NA) goto minus_i;

	old_c.val[i]=old_c.val[i]+1;
	if (old_c.val[i]>c_max) goto previous_i;	
		goto try_i;

success:

colort.adm=1;
return colort;

impossible:

colort.adm=0;
//printf("\n Sorry, I can't. You should increase the number of colors to use. At least %i",cmax+1);

return colort;
}

// ----------------------------------------------------------------------------- COLOR_3
struct position color_3(struct matrix M,struct dplus dplus,struct position color,struct param param)
{
/*
Try to improve color, only by modifying non colored nodes 
Non colored node = highly negative value NA  (global variable)

		select the non colored node i which has the largest number of colored neighbours with different colors
			in case of a tie, select the one with the largest number of colored neighbours
				in case of a tie, select at random
		option 0: assign to i the consistent color with the most occurences		
		option 1: assign the smallest possible color
*/

int					all_checked;
int					best_color;
int					best_node;
int					c,c1,c2;
struct vector_int	candidate1,candidate2;
int					c_max;

int					c_min;

struct vector_int	checked; //[color] checked
struct position		colort;
struct color_list	hood_color={0};
int					i;
int					j;
int					k;
int					l;

int					inode;
int					largest;
int					largest2;

int					max_color;
int					most;

struct vector_int	n_color;
struct vector_int	not_color;

int					OK;
int					option;


int					rank_color;
struct vector_int	used_times[2]; // [color] [number of times it is used] 

//printf("\n color_3 \n");
//display_position(color);

option=0;

max_color=(int)param.H.min[0]; // Max color ever assigned;
colort=color;

if (option==0) // Initialize used_times
{
	used_times[0].size=0;
	for (i=0;i<color.size;i++)
	{
		c=(int)color.x[i];
		if (c<=NA) continue;
			if (used_times[0].size==0) goto new_color;
				for (j=0;j<	used_times[0].size;j++)
				{
					c1=used_times[0].val[j]; // Check color
					if (c1==c)
					{
						used_times[1].val[j]=used_times[1].val[j]+1;// Already used
						goto next_node;
					}
				}
			new_color:
			used_times[0].val[used_times[0].size]=c; // New color
			used_times[1].val[used_times[0].size]=1; // Count for the first time
			used_times[0].size=used_times[0].size+1; // One more color		
	next_node:;
	}
	if (used_times[0].size==0) // If no node is already colored, assign  a random color to a random node 
	{
		i=alea(0,color.size-1); // random node
		c_min= (int) param.H.min[0];
		c_max= (int)  param.H.max[0];
		c=alea(c_min,c_max);
		used_times[0].val[0]=c;
		used_times[1].val[0]=1;
		rank_color=0;
		used_times[0].size=1;
		colort.x[i]=(float)c;
		if (param.printlevel>1)
			printf("\nWARNING. color_3: complete recoloring");
	}
}


hood_color.size=dplus.dmax;

// Compute the two criteria for the first time
largest=0;

for (inode=0;inode<M.size;inode++) // For each possible node i ...
{
	 if (colort.x[inode]>NA) continue;
	
		
	not_color.val[inode]=0;// Number of non colored neighbours
	for (i=0;i<dplus.dplus[inode].size;i++)
	{
		j=dplus.dplus[inode].val[i]; // Neighbour
		if (colort.x[j]>NA) continue;
			not_color.val[inode]=not_color.val[inode]+1;
	}
	
	hood_color.size=0;
	for (i=0;i<dplus.dplus[inode].size;i++) // Check the colors used in the hood.
	{	
		j=dplus.dplus[inode].val[i];
		if (colort.x[j]<=NA) continue;
			c=(int) colort.x[j]; // Color of the neighbour
			for (k=0;k<hood_color.size;k++)
			{
				c1=hood_color.val[k];	
				if (c1==c) goto next_i; // Already counted
			}
			hood_color.val[hood_color.size]=c; // New color
			hood_color.size=hood_color.size+1;
	next_i:;
	}



	// Count how many _different_ colors in the neighbourhood
	n_color.val[inode]=hood_color.size;
	
	// Update the largest number of different colors in the hood		
	if (n_color.val[inode]>largest)
	{
		largest=n_color.val[inode];
	}
}


for (inode=0;inode<M.size;inode++)
{
	candidate1.size=0;
	largest2=0;

	for (i=0;i<M.size;i++) // First criterion
	{
		if (colort.x[i]>NA) continue; // Already colored
		if (n_color.val[i]<largest) continue;
			candidate1.val[candidate1.size]=i;
			candidate1.size=candidate1.size+1;
			if (not_color.val[i]>largest2) largest2=not_color.val[i];
	}

	if (candidate1.size==0) goto end;

	if (candidate1.size==1)
	{
		best_node=candidate1.val[0];
		goto assign_color;
	}

	candidate2.size=0;

	for (i=0;i<candidate1.size;i++)
	{
		j=candidate1.val[i];
		if (not_color.val[j]<largest2) continue;
			candidate2.val[candidate2.size]=j;
			candidate2.size=candidate2.size+1;
	}
/*
	if (candidate2.size==0)
	{
		best_node=candidate1.val[alea(0,candidate1.size-1)];
		goto assign_color;	
	}
*/

	
	best_node=candidate2.val[alea(0,candidate2.size-1)];

assign_color:

//printf("\ncolor_3. best node %i",best_node);

c_min=(int) param.H.min[best_node];
c_max=(int) param.H.max[best_node];


if (option==0)
{
	checked.size=0; // No color checked
		c=c_min;
}
else	
{
	all_checked=1;
	c=c_min-1;
}

next_color:

//printf("\n color_3. c %i",c);

if (all_checked>0)
{
	c=c+1;
	if (c>c_max) goto warning;
	goto check;
}

//if (option==0) // ... choose the most already used consistent color;
{
		most=-1;
		OK=0;
		for (i=0;i<used_times[0].size;i++) // For each already used color ...
		{
			c1=used_times[0].val[i]; //  (color already used)
			for (j=0;j<checked.size;j++) // ... check if already checked
			{
				c2=checked.val[j];
				if (c2!=c1) continue;
					 // Already checked
					goto next_choose;
			}

			if (used_times[1].val[i]<=most) continue; // Less used
				c=c1;
				most=used_times[1].val[i];
				OK=1;
				rank_color=i;
		next_choose:;
		}

		if (OK==0) // All already used colors have been checked
		{
			all_checked=1;
			goto next_color;
		}
}

check:

//printf("\n color_3.  best_color %i ",c);

if (option==0)
{
	checked.val[checked.size]=c;// Color c is (will be) checked
	checked.size=checked.size+1;
}
	{
	// ... look if it is consistent

	for (j=0;j<dplus.dplus[best_node].size;j++) // For each possible neighbour...
		{
		k=dplus.dplus[best_node].val[j]; 
		if (color.x[k]<=NA) goto OK;// ...not colored => obviously consistent
		if (fabs(c-colort.x[k])>=M.val[best_node][k]) goto OK; // ... consistent
			goto next_color;// not consistent	
		OK:;
						
		} // next neighbour
		goto assign;

	}
	
warning:
best_color=max_color;

//printf("\n WARNING. color_3. Can't find any consistent color for node %i. Set to %i",best_node,best_color);



assign:
// Assign the color

best_color=c;

colort.x[best_node]=(float)best_color;
//printf("   best color %i",best_color);

if (best_color>max_color) max_color=best_color;


//_____________________ 
// Modify the criteria (remember the matrix is symmetric)

		for (i=0;i<dplus.dplus[best_node].size;i++) // For each best_node's neighbour ...
		{
			j=dplus.dplus[best_node].val[i]; // (neighbour)
			if (colort.x[j]>NA) continue; //  already modified

			not_color.val[j]=not_color.val[j]-1; // decrease the number of non modified j's neighbours

			for (k=0;k<dplus.dplus[j].size;k++) 
			{
				l=dplus.dplus[j].val[k];
				if (colort.x[l]<=NA) continue;
				if (colort.x[l]==best_color && l!=best_node) goto next_i3; // Color best_color already used in the neighbour 
			}

			// best_color not already used in the neighbourhood of j

			n_color.val[j]=n_color.val[j]+1;
		next_i3:;
		}
//printf("\n ici 3");
		largest=0;
		for (i=0;i<M.size;i++)
		{
			if (colort.x[i]>NA) continue;
			if (n_color.val[i]>largest)
			{
				largest=n_color.val[i];
			}
		}
//printf("\n ici 4 rank_color %i",rank_color);
		if (option==0) // Update the number of times the color is used
		{
			used_times[0].val[rank_color]=used_times[0].val[rank_color]+1;
		}

//printf("\n ici 5");
}		

end:

return colort;
}


//================================================================== COLOR_6
struct position color_6(struct matrix M,struct dplus dplus,struct position color0,int trace)
{
/* Mechanical analogy (protein folding)
Try to find an acceptable coloring "near" to color0
while stop criterion not satisfied
	for each node compute the balance of the forces along its edges
	if >0 add 1 to its color
	if <0 add -1 to its color
end while
*/
float				c1,c2;
int					coin;
float				constr;
struct position 	colort;
float				d;
float				d1,d2;
float				delta[Max_DD];
float				diff;
int					dim;
float				E0,E1,E2,Emin;
float				f0,f1;
float				f1_min,f1_max;
int					i;
int					j;
float				lambda;
int					node;
float				step;
int					too_consist;
int					uncons,uncons_max;
float				z;


if (trace>1)
{
	printf("\n Color_6");
	display_position(color0);
}

dim=M.size;


step=(float) 1.0/(dplus.dmax+1);// Warning. If you write 1/(...) some compilers give step=0 !!
lambda=1; // deadening
f0=1; // coeff for force due to unsatisfied constraint
z=(float)dplus.dtot; // Warning. As dtot*dim may be > 2^31-1, convert into float

//z=dplus0.dmax;


z=z*dim;
f1_min=(float) 2.0/(z+2);// For too consistent pairs
f1_max=(float) 4.0/(z+4);
f1=alea_float(f1_min,f1_max);

Emin=(float) 0.99999999*f0*step; // Smaller than f0*step


// WARNING. Valid only if all constraints are equal to 1

	d=0;
	for (i=0;i<dim;i++)
		{
		d=d+dplus.dplus[i].size*(dplus.dplus[i].size-1)/2;
		}
	Emin=Emin+f1*d;

/*
One unsatisfied constraint must give more energy than
all constraints too satisfied 
*/


uncons_max=0;

colort=color0;

E2=energy_color(colort,M,dplus,f0,f1);
E1=E2;
E0=E1;
if (trace>2) printf("\n Energy %.2f",E2);

loop:

uncons=0;
for (node=0;node<dim;node++) delta[node]=0; // Initialize the balance


// Forces between adjacent nodes

too_consist=0;

for (node=0;node<dim;node++) // For each node ...
	{
	d1=0;
	d2=0;
	c1=colort.x[node];
	for (i=0;i<dplus.dplus[node].size;i++) // For each neighbour ...
		{
		j=dplus.dplus[node].val[i];
		if (j<=node) continue; // Symmetrical matrix
		constr=(float)M.val[node][j];

		
//if (constr<=0) continue; // No constraint

		c2=colort.x[j];
		
		diff=(float) fabs(c1-c2)-constr;  // ... check the consistency
//printf("\n (%i/%.2f) (%i/%.2f)",node,c1,j,c2);		
		if (diff==0) continue; // Perfect
/*		
		if (diff>0) // Consistent, but too much. The spring is dilated
		{
			if (c1>c2+constr) // c1 should decrease or c2 increase => (-1,0) or (0,1)
			{
				coin=alea(0,1);
				d1=coin-1;
				d2=coin;
			}
			if (c1+constr<c2)  //c1 should increase or c2 decrease => (1,0) or (0,-1)
			{
				coin=alea(0,1);
				d1=coin;
				d2=coin-1;
			}
//printf("\ntoo consistent. %i +%.2f,  %i +%.2f",node,d1,j,d2);
			too_consist=1;
			d1=f1*d1;
			d2=f1*d2;
		}
*/			
		if (diff<0) // Unconsistent. The spring is compressed
		{
			uncons=uncons+1;
	//printf("\n uncons %i",uncons);
			// abs(c1-c2) must increase. 
			
			if (c1==c2) // Either (0,-1) or (1,0) or (-1, 0) or (0,-1)
			{
				coin=alea(1,4);
				if (coin==1) {d1=0;d2=1;}
				if (coin==2) {d1=1;d2=0;}
				if (coin==3) {d1=-1;d2=0;}
				if (coin==4) {d1=0;d2=-1;}
			}
			if (c1>c2) // (1,0) or (0,-1)
			{
				coin=alea(0,1);
				d1=(float)coin;
				d2=(float)coin-1;
			}
			
			if (c1<c2) // (-1,0) or (0,1)
			{
				coin=alea(0,1);
				d2=(float)coin;
				d1=(float)coin-1;
			}
			d1=-d1; // (because diff is <0)
			d2=-d2;
		}
//printf("\n node %i diff=%f, d1= %f, d2= %f",node,diff,d1,d2);
			
			delta[node]=delta[node]+d1*diff;
			delta[j]=delta[j]+d2*diff;	
	}//next neighbour
	//delta[node]=delta[node]-f2*c1;// Try to be as small as possible
	//delta[node]=delta[node]-f2;// Try to be as small as possible
//printf("\n reduce node %i d= %.2f",node,-f2*c1); 
	}// next node
		

//printf("\n %i unconsistencies", uncons);

//if (uncons<=uncons_max) printf("\n CONSISTENT");


// Change the colors
for (node=0;node<dim;node++) 
	{
/*
	if (delta[node]>0) {d=1;}
	if (delta[node]<0) {d=-1;}
	if (delta[node]==0) d=0;
*/
	d=delta[node];
//printf("\n node %i, color %.2f. ",node, colort.x[node]);
	colort.x[node]=colort.x[node]+d*step;
//printf(" delta %.2f, delta*step %.2f => color %.2f",delta[node],d*step,colort.x[node]);
	}
E0=E1;
E1=E2;	
E2=energy_color(colort,M,dplus,f0,f1);	
 if (trace>2) printf("\n E0 E2 %f %f",E0,E2);
// "parapet" criterion: the same energy from a too long time

if (E2>=E0) 
{
	if (trace>1) printf("\n /  Stop by no improvement");
	goto end;
}

// Normal stop criterion: energy small enough
if (E2>Emin)
{
	goto loop;
}

//--------------------
end:

if (trace >1) 
{
	display_position(colort);
	printf("\nDistance between color0 and colort: %f",distance(color0,colort));
}

uncons=check_color(convert_position_to_color(colort),M,dplus);
//Admissible ?
if (uncons==0) colort.adm=1; else colort.adm=0;

if (trace>1)
	{
	if (colort.adm==0) printf("\n color_6. (non admissible)");
	}
return colort;
}


// ----------------------------------------------------------------------------- COLOR_8
struct position	color_8(struct position color,struct matrix M, struct dplus dplus,int trace)
{
/*
Try to improve a coloring:

Built the list of the "bad" nodes (using the max color)
Try to modify the color of at least one of the bad nodes

First, try to decrease just the color of the node.
	If it works, keep this coloring, and try to improve again.
	
	If it doesn't work, try for pairs of nodes: 
	For each neighbour i, look if it has several possibilities
	all better than colort.max. For each pair of these possibilities (c,c'),
 	try to put c on i and c' on max_node.
	If it works, keep this coloring, and try to improve again.
	
	If it doesn't work, try with three nodes at a time



  If it still doesn't work, well, give up!

NOTE: valid only with granularity = 1  (colors are integers)

*/

int				c,c1,c2;
int				cmax;

struct position	colort;

int				colort_max;

int				colort_max0;
int				i;
int				improv;
int				j,j1,j2;
int				k,k1,k2;
int				maxcolor;
int				n_not;
int				neighbour1,neighbour2;

int				OK;


int				worst;
struct vector_int	worst_node;


if (trace>0)

	{
	printf("\n Color_8 (improvement) ");	
	}

colort=color;
colort_max=diff_color(colort);// Max number of different colors
improv=0; // No improvement, to begin!

improve:
OK=0;


// Built the list of the "bad" nodes (using the max color)
maxcolor=0;
for (i=0;i<colort.size;i++) // Find the max color
	if (colort.x[i]>maxcolor) maxcolor=(int) colort.x[i];


	
worst_node.size=0; // Built the list
for (i=0;i<colort.size;i++)
	{
	if (colort.x[i]<maxcolor) continue;
		worst_node.val[worst_node.size]=i;
		worst_node.size=worst_node.size+1;
	}



// Try to modify the color of at least one of the worst nodes

for (i=0;i<worst_node.size;i++)
	{
	worst=worst_node.val[i];

	cmax=(int) color.x[worst];
	if (cmax<maxcolor) continue; // (it may already have been improved as a neighbour)
	
	for (c=0;c<cmax;c++) // try a new color for "worst"
		{
		n_not=0;
		for (j=0;j<dplus.dplus[worst].size;j++) // try each neighbour
			{
			k=dplus.dplus[worst].val[j]; // (k is the neighbour of "worst")
			if (fabs(c-colort.x[k])<M.val[worst][k])   // not consistent
				{
				n_not=n_not+1;
				if (n_not>2) 
					{
					goto next_c ; // We admit just two not consistent neighbours
					}
				if (n_not==1) neighbour1=k;
				if (n_not==2) neighbour2=k;
				}		
			}

		
		if (n_not==0) // super lucky, just one color to change!
			{
			OK=OK+1;
			colort.x[worst]=(float)c;

			//colort_max=diff_color(colort);// Max number of different colors
			goto next_worst;
			}
			
		if (n_not==1)// just one non consistent neighbour
		{


			for (c1=0;c1<cmax;c1++) // try a new color for the neighbour
			{
				if (fabs(c-c1)<M.val[worst][neighbour1]) goto next_c1; // not consistent
			
				for (j=0;j<dplus.dplus[neighbour1].size;j++) // check each neighbour of the neighbour
				{
					k=dplus.dplus[neighbour1].val[j]; // (k is the neighbour of the neighbour)
					if (k==worst) continue; // (already checked: for this pair of node, we try (c1,c))
						if (fabs(colort.x[k]-c1)<M.val[neighbour1][k]) goto next_c1; // not consistent
				}			
				// colors (c,c1) are OK for nodes (worst,neighbour1)
				OK=OK+1;
				colort.x[worst]=(float)c;
				colort.x[neighbour1]=(float)c1;


				goto next_worst;	
				
				next_c1:; // next color for the neighbour of the worst node
			}
		} // end of the case "one unconsistent neighbour"
			
		if (n_not==2) // just two non consistent neighbours
			{


			for (c1=0;c1<cmax;c1++)
				{
				if (fabs(c-c1)<M.val[worst][neighbour1]) goto next_c1_2; // not consistent
						
				// Check the neighbours of neighbour1
				
				for (j1=0;j1<dplus.dplus[neighbour1].size;j1++)
					{
					k1=dplus.dplus[neighbour1].val[j1]; // k1 is a neighbour of neigbour1
					if (k1==worst) continue;
					if (k1==neighbour2) continue;


					if (fabs(colort.x[k1]-c1)<M.val[neighbour1][k1]) goto next_c1_2; // not consistent
					}
				
				for (c2=0;c2<cmax;c2++)
					{
					if (fabs(c-c2)<M.val[worst][neighbour2]) goto next_c2; // not consistent
					if (fabs (c1-c2)<M.val[neighbour1][neighbour2]) goto next_c2; // not consistent	
						
						// Check the neighbours of neighbour2
				
					for (j2=0;j2<dplus.dplus[neighbour2].size;j2++)
						{
						k2=dplus.dplus[neighbour2].val[j2]; // k2 is a neighbour of neigbour1
						if (k2==worst) continue;
						if (k2==neighbour1) continue;
						if (fabs(colort.x[k2]-c2)<M.val[neighbour2][k2]) goto next_c2; // not consistent
						}
						
					// colors (c,c1,c2) are OK for nodes (worst,neighbour1,neighbour2)
					OK=OK+1;
		//printf("\n 	%i/%i %i/%i %i/%i",worst,c,neighbour1,c1,neighbour2,c2);
					colort.x[worst]=(float)c;
					colort.x[neighbour1]=(float)c1;
					colort.x[neighbour2]=(float)c2;
					
					goto next_worst;	
					next_c2:;	
					}	
				next_c1_2:;
				}
			}// end of the case "two unconsistent neighbours"
				
		next_c:; // next color for a worst node
		}
	next_worst:;
	} // next worst node


colort_max0=colort_max;
colort_max=diff_color(colort);// Max number of different colors


if (colort_max>=colort_max0)	// Noimprovement
	{
	return colort;
	}
else
	{
	goto improve; 
	}

}

// ----------------------------------------------------------------------------- COLOR_8_1
struct position	color_8_1(struct position color,struct matrix M, struct dplus dplus,int trace,struct param param,struct model model)
{
/*
Try to improve a coloring:

Built the list of the "bad" nodes (using the max color)
For each one, build a subgraph, and try to improv its coloring

for model.local_search >= 2

*/

int					backtrack;
struct vector_int	bad_node;
float				c,c1;
struct position		color0;
struct position		color1;
struct position		color3;
struct position		color_best;
float				d;
int					i;
int					j;
int					k;
int					l,l1;
int					m,m1;
float				max_unsat;
int					node;
int					parallel;
int					search;
float				total;
float				unsat;

parallel=1;
backtrack=0;


if (trace>0)
{
	printf("\n COLOR_8_1");
}

//printf("\n  %f ",color.f);
search=model.local_search;

color_best=color;

//printf("\n color_8_1 ici1 %i",color.size);
// Built the list of the "bad" nodes 

// Bad node = generating the greatest unsatisfaction

// Find the max
max_unsat=(float)NA;
for (node=0;node<color.size;node++)
{ 
	unsat=0;
	c=color.x[node];
	for (j=0;j<dplus.dplus[node].size;j++) // Neighbours
	{
		k=dplus.dplus[node].val[j];
		c1=color.x[k];
		d=(float)M.val[node][k]-(float) fabs(c-c1);
		if (d>0) unsat=unsat+d;
	}
	if (unsat>max_unsat) max_unsat=unsat;
}

// Build the list
bad_node.size=0;
for (node=0;node<color.size;node++)
{ 
	unsat=0;
	c=color.x[node];
	for (j=0;j<dplus.dplus[node].size;j++) // Neighbours
	{
		k=dplus.dplus[node].val[j];
		c1=color.x[k];
		d=(float)M.val[node][k]-(float)fabs(c-c1);
		if (d>0) unsat=unsat+d;
	}
	if (unsat<max_unsat) continue;
		bad_node.val[bad_node.size]=node;
		bad_node.size=bad_node.size+1;
}

if(trace>1)
{
	printf("\n max_unsat %f. Bad nodes",max_unsat);
	for (node=0;node<bad_node.size;node++) printf( " %i",bad_node.val[node]);
}

/*  OLD METHOD-----------
// Bad node = using the max color
maxcolor=NA;
for (i=0;i<color.size;i++) // Find the max color
	if (color.x[i]>maxcolor) maxcolor=color.x[i];
	
bad_node.size=0; // Build the list
for (i=0;i<color.size;i++)
	{
	if (color.x[i]<maxcolor) continue;
		bad_node.val[bad_node.size]=i;
		bad_node.size=bad_node.size+1;
	}
 --------------- */

erase:
color1=color;

for (i=0;i<bad_node.size;i++)
{
	// Set the subgraph
	node=bad_node.val[i]; // First node
	color1.x[node]=(float)NA;
	if (search<3) continue;
	
//printf("\n node %i",node);	
	for (j=0;j<dplus.dplus[node].size;j++) // Neighbours
	{
		k=dplus.dplus[node].val[j];
		color1.x[k]=(float)NA;
//printf("\n level 1 %i",k);
		if (search<4) continue;
	
			for (l=0;l<dplus.dplus[k].size;l++) // Neighbours of neighbours
			{
				m=dplus.dplus[k].val[l];
				color1.x[m]=(float)NA;

//printf("\n level 2 %i",m);

				if (search>=4)
				{
					for (l1=0;l1<dplus.dplus[m].size;l1++) // Neighbours of neighbours
					{
						m1=dplus.dplus[m].val[l1];
						color1.x[m1]=(float)NA;
//printf("\n level 3 %i",m1);
					}
				}
			}
	
	}


	if(parallel==0) // Try for each small subgraph at a time

	{
		// Find a coloring for the subgraph 
		if (backtrack>0)

		{
			color0=color_0(M,dplus,color1,param); // Try local backtrack 

			total=tot(color0, param, model);       //evaluation of the position
			color0.f=eval(total,param.target);

			if (color0.f<color_best.f)
			{
				color_best=color0;
				goto next_bad_node;
			}
		}
	
// Check if there is still something colored

for (i=0;i<color.size;i++)
{
	if (color1.x[i]>NA) goto recolor;
}
search=search-1;
if (search>1) goto erase;

//----------	
recolor:		
		color3=color_3(M,dplus,color1,param);
	
		// Check if better. If so, keep it
	
		total=tot(color3, param, model);       //evaluation of the position
		color3.f=eval(total,param.target);

		if (color3.f<color_best.f)
		{
			color_best=color3;
			goto next_bad_node;
		}
	}
next_bad_node:;
}




if(parallel>0) // Try just once, but for the union of the subgraphs

{

//printf("\n color_8_1. before backtrack");	

	// Find a coloring for the subgraph 
	if (backtrack>0)
	{
		color0=color_0(M,dplus,color1,param); // Try local backtrack 

		// Check if better. If so, keep it

		total=tot(color0, param, model);       //evaluation of the position
		color0.f=eval(total,param.target);
		if (color0.f<color_best.f)
			{
				color_best=color0;
			}
	}

//printf("\n color_8_1. after backtrack");
//printf("\n color_8_1. before greedy");

	// Try a greedy algo for approximate solution
	color3=color_3(M,dplus,color1,param);
	total=tot(color3, param, model);       //evaluation of the position
	color3.f=eval(total,param.target);
	if (color3.f<color_best.f)
	{
		color_best=color3;
	}
//printf("\n color_8_1. after greedy");
}

return color_best;
}

// ----------------------------------------------------------------------------- COLOR_LOCAL_SEARCH
struct position color_local_search(struct position pos,struct param param,struct model model)
{
int				type;
struct position post;

type=model.local_search;


switch (type)
{
	case 1:
	post=color_8(pos,M,  dplus,0);
	break;

	default:
	post=color_8_1(pos,M,dplus,0,param,model);
	break;

}


if (post.f<pos.f && param.printlevel>1)

//if (post.f<pos.f)

{ 
	printf("\n color_local_search %f => %f",pos.f,post.f);
}

return post;
}

// ----------------------------------------------------------------------------- COLOR_SHIFT
struct position color_shift (struct position pos)
{
// Change all colors/frequencies so that the min one is zero
// It does NOT change the f value of the position (see tot_color)
//Global variable  NA is big negative number. Means "non assigned"

int				d;
float			c_min;
struct position post;

c_min=min_comp(pos);
//printf("\n color_shift. min %f",c_min);
//display_position(pos);

if (c_min==0) return pos;

post=pos;

	
for (d=0;d<post.size;d++)
	{
	if (post.x[d]<=NA) continue;
		post.x[d]=pos.x[d]-c_min;
	}

return post;
}


// ----------------------------------------------------------------------------- CONVERT_COLOR_TO_POSITION
struct position	convert_color_to_position(struct color color)
{
/*
struct color		{int size;int val[Max_DD];int max;int adm;};
struct position		{int size;float x[Max_DD];float f;float ep;float prev_f[10];};


WARNING: you need to use complete_part() after that, or, at least
to evaluate pos.f
*/
int				i;
struct position pos;

for (i=0;i<color.size;i++)
{
	pos.x[i]=(float)color.val[i];

}
pos.size=color.size;
return pos;

}


// ----------------------------------------------------------------------------- CONVERT_POSITION
struct position	convert_position(struct position pos)
{
/*
Conversion before to display/result.
FAP/LCP particular case (the internal representation of a position is not
directly the coloring)
*/
float			DD;
struct position post;


post=pos;
DD=(float)pos.size;

	
// Shift

post=color_shift(pos);
	

/*
// Scale 

for (d=0;d<pos.size;d++)
	{
	post.x[d]=post.x[d]/DD;
	}
*/

return post;
}

// ----------------------------------------------------------------------------- CONVERT_POSITION_TO COLOR
struct color	convert_position_to_color(struct position pos)
{
/*
struct position		{int size;float x[Max_DD];float f;float ep;float prev_f[10];};
struct color		{int size;int val[Max_DD];int max;int adm;};

WARNING: after that, you need to use diff_color() and to evaluate if it is admissible or not 
*/
int				i;
struct color 	color;

for (i=0;i<pos.size;i++)
{
	color.val[i]=(int)pos.x[i];

}
color.size=pos.size;
return color;

}

// ----------------------------------------------------------------------------- DIFF_COLOR
int diff_color(struct position color)
{
// Count how many different colors are used
// WARNING: global variable NA must be <0 and abs(NA) must be greater than any possible color. NA means non assigned
int					c;
int					i0,i,j;
int					n_color;
int					times[1001];


for (i0=0;i0<color.size;i0++)
{
	c=(int)color.x[i0];
	if (c<=NA) continue;
		times[i0]=c;
		n_color=1;
		goto diff;	
}
return 0;


diff:
if (i0==color.size-1) return n_color;

for (i=i0+1;i<color.size;i++)
{
	c=(int)color.x[i];
	if (c<=NA) continue;


	for (j=0;j<n_color;j++)
	{
		if (c==times[j]) goto next_i;
	}
	times[n_color]=c;
	n_color=n_color+1;

next_i:;
}

return n_color;

}


// ----------------------------------------------------------------------------- DIFF_COLOR_LIST
struct vector diff_color_list(struct position color)
{
// Find the list of different colors used
// WARNING: global variable NA must be <0 and abs(NA) must be greater than any possible color. NA means non assigned
float					c;

struct vector		color_list;
int					i0,i,j;


color_list.size=0;
for (i0=0;i0<color.size;i0++)
{
	c=color.x[i0];
	if (c<=NA) continue;
		color_list.x[color_list.size]=c;
		color_list.size=1;
		goto diff;	
}
return color_list; // No assigned colors at all


diff:
if (i0==color.size-1) return color_list; // Just one color

for (i=i0+1;i<color.size;i++)
{
	c=color.x[i];
	if (c<=NA) continue;


	for (j=0;j<color_list.size;j++) // Check if already counted
	{
		if (c==color_list.x[j]) goto next_i;
	}
	color_list.x[color_list.size]=c;
	color_list.size=color_list.size+1;

next_i:;
}

return color_list;


}

// ----------------------------------------------------------------------------- DISPLAY_MATRIX
void display_matrix(struct matrix M)
{
int	i,j;

printf("\n\n Matrix, size %i \n",M.size);

for (i=0;i<M.size;i++)
{
	for (j=0;j<M.size;j++)
		printf("%i ",M.val[i][j]);
	printf("\n");
}
}

// ----------------------------------------------------------------------------- ENERGY_COLOR
float energy_color (struct position color,struct matrix M,struct dplus dplus,float f0,float f1)
{
int i,j,k;
float d;
float e=0;

for (i=0;i<M.size;i++)
	{
	for (j=0;j<dplus.dplus[i].size;j++)
		{
		k=dplus.dplus[i].val[j];
		if (k<=i) continue; // Symmetric matrix
		
		d=(float)fabs(color.x[i]-color.x[k])-M.val[i][k];
		if (d>0) d=f1*d; // Too satisfied constraint
		if (d<0) d=-f0*d; // Unsatisfied constraint
		e=e+d;
//printf("\n (%i,%i) d_energy %f",i,k,d);	
		}
	}

return e;
}

// ----------------------------------------------------------------------------- GENER_PARTICLE_COLOR
struct particle	gener_particle_color(struct swarm sw,int part_rank,struct param param,struct model model)
{
/* Generate a new particle, according to the particle of rank part_rank (supposed to be a good one)

*/
int				g;
struct subswarm	hood;
int				i;
struct particle part0,part1,part;


//printf("\n gener_particle_color");


part0=sw.part[part_rank];

// Find another good particle, as far as possible

i=part_rank+sw.size/2;
if (i>=sw.size) i=i-sw.size;

 //  ... find neighborhood best (sequential)
hood=hood_swarm(sw,i,param.eps);
g=hood.rank[hood.best];

part1=sw.part[g];

// Combine part1 and part2

part=part0;

/*
for (i=0;i<part0.pos.size;i++)
{
	r=alea_float(0,1);
	if (r<0.5)
	{
		part.pos.x[i]=part1.pos.x[i];
		part.vel.v[i]=part1.vel.v[i];
	}
}
*/

i=alea(0,part0.pos.size-1);

part.pos.x[i]=alea_float(param.H.min[i],param.H.max[i]); // Partial cloning
part.vel.v[i]=0;


part.pos.label=label[level];

label[level]=label[level]+1;
part.prev_best.label=label[level];
part=complete_part(part,param, model);


//printf("  %f => %f",part0.pos.f,part.pos.f);
//display_position(part0.pos);
//display_position(part.pos);
return part;
}


// ----------------------------------------------------------------------------- INIT_COLOR_1
struct position init_color_1(struct matrix M, struct dplus dplus,int cmin, int cmax)
{
/*
while there is a non colored node
	choose at random a non colored node i
	assign to i a randomly chosen consistent color
end while
*/
int					c;
struct position 	color;
struct vector_int	colored_nodes;
struct vector_int	color_values;
struct vector_int	non_colored_nodes;
int					i;
int					j;
int					k;

int					node;
int					rank;


color.size=M.size;

//printf("\n Random coloring 1");

non_colored_nodes.size=M.size; // At the beginning, all nodes are not colored
for (i=0;i<M.size;i++)
	non_colored_nodes.val[i]=i;
	
colored_nodes.size=0; // No colored nodes at all

// Set color to NA (arbitrary negative value for "not colored")

for (i=0;i<color.size;i++) 
	color.x[i]=(float)NA;


next_node:

// Choose at random a non colored node

rank=alea(0,non_colored_nodes.size-1);
node=non_colored_nodes.val[rank];

//printf("\n rank, size, node, %i %i %i",rank,non_colored_nodes.size,node);

// Build a list of consistent colors for the current node
// according to the nodes already colored

color_values.size=0;
c=cmin; 

try_c:
if (colored_nodes.size>0)
{
	check_color:
	
	for (i=0;i<dplus.dplus[node].size;i++) // For each neighbour
	{
		j=(int)dplus.dplus[node].val[i];
		k=(int)color.x[j]; // ... check the color
		if (k<=NA) continue; // ... not colored => consistent
			if (fabs(c-k)<M.val[node][j]) // If color c is not admissible ...
			{
				c=c+1; // ... increase it ...
				goto check_color; // ... and try again.
			}
	}
}
	
color_values.val[color_values.size]=c;
color_values.size=color_values.size+1;
if (c<cmax && color_values.size<Max_DD)
{
	c=c+1;
	goto try_c;
}
	
// Choose one at random

c=color_values.val[alea(0,color_values.size-1)];
	
//printf("\n  coloring node %i",node+1);
//printf(" with color %i",c);

colored_nodes.val[colored_nodes.size]=node; // Save which node has been colored
colored_nodes.size=colored_nodes.size+1; 
color.x[node]=(float)c; // Save the color of the node
if (colored_nodes.size>=color.size) goto end;

// Compact the list of non colored nodes

if (rank<non_colored_nodes.size-1)
{
	for (i=rank;i<non_colored_nodes.size-1;i++)
	{
		non_colored_nodes.val[i]=non_colored_nodes.val[i+1];
	}
	non_colored_nodes.size=non_colored_nodes.size-1;
}

// Loop as long as some nodes are still not colored
goto next_node;

end:
//display_position(color);

return color;
}


// ----------------------------------------------------------------------------- INIT_PARTICLE_COLOR
struct particle	init_particle_color(struct param param,struct model model, struct matrix M, struct dplus dplus,int type)
{ // Special initialization of a particle for Coloring/Frequency assignment problem
int				cmax;
int				d;
struct particle part;
int				xmin,xmax;


//printf("\n init_particle_color, type %i. H = %i",type,H);


part.pos.size=param.DD;
part.vel.size=param.DD;
part.H=H; // Useful for model.H=3
H=3-H; // Switch projection space

xmin=(int)param.H.min[0];
xmax=(int)param.H.max[0]; // Maximum possible color

cmax=(int)param.max_fr; // Max number of colors wanted

if (param.combin==0)
{
	for( d = 0;d<param.DD;d++)  //for each dimension
	{
		part.vel.v[d] = 0;

		//part.vel.v[d] = alea_float(param.H.min[d],param.H.max[d]);
	}
}
else
{
part.vel=alea_velocity (param.DD,param); // Cf combinatorial kit
}
part.vel.ek=0; // Kinetic energy



if (type==-1) // Generate a "null" particle
{
	for( d = 0;d<param.DD;d++)  //for each dimension
	{
		part.pos.x[d] = 0; 
	}

	return part;
}

if (type==-2) // Generate a special particle
{
	for( d = 0;d<param.DD;d++)  //for each dimension
	{
		  part.pos.x[d] = (float)dplus.dplus[d].size; 
	}

	return part;
}


if (model.init_type==0) // Random
{
	for( d = 0;d<param.DD;d++)  //for each dimension
	{
		part.pos.x[d] = (float)alea((int)param.H.min[d],(int)param.H.max[d]);   //x(i,d) in [xmin, xmax]
	}

}
		

if (model.init_type==1) // Use init method 1
{
	part.pos=init_color_1( M, dplus,xmin,xmax);
}



return part;
}

// ----------------------------------------------------------------------------- MAX_COLOR_RANK
int	max_color_rank(struct position pos)
{
// Give the rank of a node with the max color
float	cmax;
int	i;
int	max;
struct vector_int	rank;

// Find the max color
max=0;
cmax=pos.x[0];

for (i=1;i<pos.size;i++)
{
	if (pos.x[i]<=cmax) continue;
		cmax=pos.x[i];
		max=i;
}

// Build the list of "bad" nodes
rank.size=0;
for (i=0;i<pos.size;i++)
{
	if (pos.x[i]<cmax) continue;
		rank.val[rank.size]=i;
		rank.size=rank.size+1;
}

// Choose one at random
i=alea(0,rank.size-1);
max=rank.val[i];

return max;
}

// ----------------------------------------------------------------------------- MINIMIZE_COLOR
struct particle minimize_color(struct particle part,int cmax)
{
/*
Try to find the nearest position with just cmax colors, even if some constraints are not satisfied


while there is too many different colors
	choose the color which is involved in the fewest number of constraints
	replace it by the nearest different color already used
	

*/

float			c;
int				i;
float			new_color;
int				node;
struct particle	partt;
struct vector	color_list;
float			total;
float			tot_min;
float			worst_color;

//printf("\n minimize_color");
partt=part;

check:

color_list=diff_color_list(partt.pos);


//printf("\n minimize_color %i / ",color_list.size);

/*
for (i=0;i<color_list.size;i++)
	printf(" %.0f",color_list.x[i]);
*/


	
if (color_list.size<=cmax) 

{

//printf("\n end of minimize_color");	

	return partt;

}

//display_position(partt.pos);
// Find the worst color
tot_min=(float)dplus.dtot+1; 

for (i=0;i<color_list.size;i++)
{
	c=color_list.x[i]; // color to check
	
	total=0;
	for (node=0;node<M.size;node++)
	{
		if (partt.pos.x[node]!=c) continue;
			total=total+dplus.dplus[node].size;
	}
	if (total<tot_min)
	{
		worst_color=c;
		tot_min=total;
	}
}

// Find the nearest different color already used

new_color=(float)-NA; // Arbitrary too big value

for (i=0;i<color_list.size;i++)
{
	c=color_list.x[i];
	if (c==worst_color) continue;
		if (fabs(c-worst_color)<fabs(new_color-worst_color))
		{
			new_color=c;
		}
}

//printf("\n minimize_color, worst %f , new %f",worst_color,new_color);
// Replace the worst color

for (node=0;node<M.size;node++)
{

	c=partt.pos.x[node];

	if (c==worst_color) 
	{
		partt.pos.x[node]=new_color;
	}
}
goto check;

}


// ----------------------------------------------------------------------------- MINIMIZE_CONSTRAINT
struct particle	minimize_constraint(struct particle part)
{
/* 
For Coloring problem/Frequency assignment, try to adapt the position so that all constraints are respected, 
eventually by increasing the number of colors used

Note: matrix M and table dplus are global variables

while there is a non respected constraint
	choose the node which has the greatest number of  non respected constraints
	modify its color as few as possible so that all its constraints are respected


*/
float			c0,c,c1;
float			d;
int				i;
int				j;
int				k;

float			m;
float			total;
float			tot_max;

struct particle partt;
int				worst_node;



partt=part;

check:

// Find the worst node 

tot_max=0;
 
for (i=0;i<M.size;i++)
	{
		total=0;
		c=partt.pos.x[i]; // color of node i
		for (j=0;j<dplus.dplus[i].size;j++)
		{
			k=dplus.dplus[i].val[j]; // k = neighbour of node i
			c1=partt.pos.x[k]; // color of node k
			d=M.val[i][k]-(float)fabs(c-c1);
			if (d>0) 
			{
				total=total+d; // How much this constraint is not satisfied
			}
		}
		if (total>tot_max)
			{
			tot_max=total;
			worst_node=i;
			}
	}
	
if (tot_max==0) goto end;	
	
// If found, change its color as few as possible so that all
// its constraints are respected, if possible	
	
m=0;
c0=partt.pos.x[worst_node];

next_color:
m=m+1;	
c=c0+m; // color of worst_node

for (j=0;j<dplus.dplus[worst_node].size;j++)
{
	k=dplus.dplus[worst_node].val[j]; // k = neighbour of worst_node
	c1=partt.pos.x[k]; // color of node k
	d=M.val[worst_node][k]-(float)fabs(c-c1);
	if (d>0) 
	{
		goto minus_m;
	}
}
 goto assign_color;

minus_m:
c=c0-m;
for (j=0;j<dplus.dplus[worst_node].size;j++)
{
	k=dplus.dplus[worst_node].val[j]; // k = neighbour of worst_node
	c1=partt.pos.x[k]; // color of node k
	d=M.val[worst_node][k]-(float)fabs(c-c1);
	if (d>0) 
	{
		goto next_color;
	}
}

assign_color:
partt.pos.x[worst_node]=c;
goto check;



end:


return partt;

}

// ----------------------------------------------------------------------------- READ_MATRIX_COLOR
struct matrix read_matrix_color(FILE *f_data, float used_constr)
{
int				i;
int				j;
struct matrix	M;
int				nothing; // Just to skip column and row number by reading the file
float			z;

fscanf (f_data,"%i",&M.size); // WARNING ***: Must be equal to param.DD

for (i=0;i<M.size;i++) fscanf(f_data,"%i",&nothing); // Column numbers

for (i=0;i<M.size;i++)
	{
	fscanf(f_data,"%i",&nothing); // row number
	for (j=0;j<M.size;j++)
		fscanf(f_data,"%i",&M.val[i][j]);
	}

// Check matrix

M.nb_cont=0; // Number of constraints
M.max_cont=0; // Maximum constraint
for (i=0;i<M.size-1;i++)
{
	for (j=i+1;j<M.size;j++)
	{
		if (M.val[i][j]>0)
		{ 
			M.nb_cont=M.nb_cont+1; // Number of constraints
			if (M.max_cont<M.val[i][j]) M.max_cont=(float)M.val[i][j];
		}
		if (M.val[i][j]!=M.val[j][i])
		{
			printf("\nERROR, read_matrix. matrix not symmetrical (%i, %i)",i,j);

infinite:;goto infinite;
		}
	}
}

// Eventually, simplify it, relaxing some constraints

if (used_constr<1)
	{
	printf("\n WARNING! As required, I use only %f percent of the constraints",100*used_constr);
	for (i=0;i<M.size-1;i++)
		{
		for (j=i+1;j<M.size;j++)
			{
			if (M.val[j][i]>0)
				{
				z=alea_float(0,1);
				if (z>used_constr)
					{
					M.val[j][i]=0;
					M.val[i][j]=0;
					}	
				}
			}
		}
	}

// Analyze the matrix (list of neighbours for each node)
// Note: dplus is a global variable

for (i=0;i<M.size;i++)
{
	dplus.dplus[i].size=0;
	for (j=0;j<M.size;j++)
	{
		if (j==i) continue; // No loop
		if (M.val[i][j]>0)
		{
			dplus.dplus[i].val[dplus.dplus[i].size]=j; // Build the list of neighbours
			dplus.dplus[i].size=dplus.dplus[i].size+1;
		}
	}
}

dplus.dmax=dplus.dplus[0].size;
dplus.dtot=dplus.dmax;

for (i=1;i<M.size;i++) 
{
	if (dplus.dplus[i].size>dplus.dmax) dplus.dmax=dplus.dplus[i].size; // Max of neighbours
	dplus.dtot=dplus.dtot+dplus.dplus[i].size; // 2*(Total number of constraints)
}



//display_matrix(M);

return M;
}


// ----------------------------------------------------------------------------- TOT_COLOR
float tot_color(struct position pos,struct matrix M,int cmax,int save)
{
/* Objective function for Cloring/Frequency Assignment problem
M is the symmetrical constraint matrix.
cmax is the maximum number of colors wanted

We must have abs(pos(i)-pos(j))>=M(i,j)
So we define d(i,j)=0 if it's OK
                   =M(i,j)-abs(pos(i)-pos(j)) else
The first part of objective function value is the sum of all d(i,j), + 1

The second part is depending on the number of different colors/frequencies used, compared to the wanted value.
We define the function so that its maximum value is <1.

We assume the position is on a projective hyperplan, so that all coordinates have to be
divided by the dimension, in order to find the right pos(i)-pos(j)

*/

float	coeff1,coeff2;
float	DD;
float	d;
//float	fr[100];
int		i;
int		j;
int		k;
int		n_col;
int		option;
float 	total1,total2,total;

//printf("\n tot_color");
//display_position(pos);


option=0; // it is more important to have the minimum number of colors
option=1; // It is more important to have no interference


coeff1=1; // For number of unsatisfied constraints
coeff2=1;// For number of different colors


DD=(float)pos.size; // (Must be equal to M.size)
total1=0;
for (i=0;i<DD;i++) 
{
	for (k=0;k<dplus.dplus[i].size;k++)
	{
		j=dplus.dplus[i].val[k];
		
		//d=M.val[i][j]-fabs(pos.x[i]-pos.x[j])/DD;
		d=M.val[i][j]-(float)fabs(pos.x[i]-pos.x[j]);
		if (d>0) 
		{
			total1=total1+1;// Add to the number of unsatisfied constraints (* 2)
			//total1=total1+d; // How much this constraint is not satisfied (method 1)
			//total1=total1+d*d; // How much this constraint is not satisfied (method 2)
		}
	}
}

/*
if (total1>dplus.dtot)
{
	printf("\n ERROR. tot_color. total1 %f > dplus.dtot %i",total1,dplus.dtot);
	infinite:;goto infinite;
}
*/

total1=total1/dplus.dtot; // On [0,1]

//Take into account the number of colors used

n_col=diff_color(pos);

if (n_col>cmax)
	{
		//total=total+(n_col-cmax)/(M.size+1);

		total2=(float)(n_col-cmax);
	}
else
	total2=0;
	
if (n_col>=M.size)// On [0,1]
{
	total2=1;
}
else
{
	total2=total2/(M.size-cmax); 
}



if (save==12)
{
	fprintf (f_move_color,"\n %.0f %f %f",pos.label,total1,total2);
}

total=(coeff1*total1+coeff2*total2)/(coeff1+coeff2); // On [0,1]

//printf("\nlabel %.0f.  total1, total2, total %f %f %f",pos.label,total1, total2,total);

X1=total1; // For Leonardo visualization
X2=total2; 

return total;


}

// ----------------------------------------------------------------------------- UPDATE_VEL_COLOR
struct velocity update_vel_color(struct position pos,struct velocity v0,struct velocity v2,float alpha,float b)
{
/*
Note, dplus is a global variable for a edge list representation of M

Option 0: classical weighting
Option 1: "combinatorial" one
*/
float			ca,cab,cb;
struct vector	g;
int				i,j,k;
int				n;
int				n1,n2;
int				option;
struct vector	used={0};
struct velocity v;//{int size;float v[Max_vel];float ek;float v2[Max_vel];int combin;}

option=0;

if (option==0)
{
	v.size=v0.size;
	v.combin=v0.combin;

	for (i=0;i<v.size;i++)
	{
		v.v[i]=alpha*v0.v[i]+b*v2.v[i];
	}


	return v;
}

//  OLD 


v=v0; // First, just take the initial velocity
cab=alpha+b;
ca=alpha/cab;
cb=b/cab;
n=(int)(0.5+cb*v2.size);// Evaluate how many components of v2 has to be taken into account
if (n==0) return v;


//printf("\n update_vel_color, coeffs %f %f, n=%i",ca,cb,n);
/*
display_velocity(v0);
display_velocity(v2);
*/


/* --------
The graph has N nodes.
- choose a node at random
- from this node, build a connexe graph (as dense as possible) with n nodes
- take just the velocity components corresponding to the nodes of this subgraph

*/

//i=alea(0,v2.size-1); // Choose the first node
i=max_color_rank(pos);
g.x[0]=(float)i;
g.size=1;
used.x[i]=1;
//printf("\n   nodes %i",i);

if (n>1)
{
	for (j=0;j<g.size;j++) // For each node already used
	{
		n1=(int)g.x[j]; // n1 = node already used
		
		for (k=0;k<dplus.dplus[n1].size;k++)
		{
			n2=dplus.dplus[n1].val[k];
			if (used.x[n2]==1) continue; // Already used
			g.x[g.size]=(float)n2;		
			used.x[n2]=1;
			g.size=g.size+1;  // Note the trick: the upper bound of the loop is modified inside the loop
//printf(" %i",n2);
			if (g.size>=n) goto end;
		}
	}
}

end:

for (i=0;i<g.size;i++) 
{
	j=(int)g.x[i];
	v.v[j]=v2.v[j];
}

//display_velocity(v);
printf("\n %f",v.v[0]);

return v;
}

// ----------------------------------------------------------------------------- UPDATE_VEL_COLOR2
struct velocity update_vel_color2(struct position pos,struct velocity v0,struct velocity v2,float alpha,float b,int cmax)
{
/*
Note: the matrix M and the edge list dplus are global variables
		H is also a global variable (for projections).

x is a position/coloring C0
x+v0 is the next position C1 if the particle follows its own way
x+v2 is another position/coloring C2 (usually the best ever found the neighbourhood

The particle moves (virtually) to C1, and update this position according to C2 and the coeffs, 
but only if it improves it.
*/

int					i;
int					j;
int					k,k_tot;
float				lambda;
int					loop;
int					loop_max;
struct vector_int	nodes;
struct vector_int	not_used;
struct velocity		v;
struct position		pos1,pos2,pos3;


loop_max=dplus.dmax;

//printf("\n update_vel_color2. loop_max=%i. begin",loop_max);
//display_position(pos);
//display_velocity(v2);

pos1=pos;
pos2=pos;

for (i=0;i<pos.size;i++) 
{
	pos1.x[i]=pos.x[i]+v0.v[i];// Define position 1, if the particle follows its own way
	pos2.x[i]=pos.x[i]+v2.v[i]; // Position2, Usually the best known position in the neighbourhood
}

lambda=alpha/(alpha+b);
k_tot=(int)(1-lambda)*pos.size;

if (k_tot<1) k_tot=1;

//printf(" (k_tot=%i)",k_tot);

loop=0;
loop:

//printf(" %i",loop);

// Define a list of k nodes to modify

not_used.size=pos.size;

for (i=0;i<not_used.size;i++)
{
	not_used.val[i]=i;
}

nodes.size=0;

for (k=0;k<k_tot;k++)
{
	i=alea(0,not_used.size-1);
	nodes.val[nodes.size]=not_used.val[i]; // Node to use
	nodes.size=nodes.size+1;

	// Compact not_used

	if (i==not_used.size-1)
	{
		not_used.size=not_used.size-1;
		continue;
	}

	for (j=i;j<not_used.size-1;j++)
	{
		not_used.val[j]=not_used.val[j+1];
	}
	not_used.size=not_used.size-1;
}

// Modify the nodes


pos1.f=tot_color(pos1,M,cmax,0);
pos3=pos1;

for (k=0;k<nodes.size;k++) 
{
	i=nodes.val[k];
	pos3.x[i]=pos2.x[i];	
}

// Check if better

pos3.f=tot_color(pos3,M,cmax,0);

if (pos3.f<pos1.f) goto end;


	// Try again
	loop=loop+1;
	if (loop<loop_max) goto loop;

	
end:

//printf("\n update_vel_color2. %f %f",pos1.f,pos3.f);
//display_position(pos3);

v=v0;
for (i=0;i<v.size;i++)
{
	v.v[i]=pos3.x[i]-pos.x[i];
}


//printf("\n update_vel_color2 pos3(10), pos(10), v(10) %f %f %f",pos3.x[10],pos.x[10],v.v[10])
//printf("  end");

return v;
}
